#include "stdafx.h"
#include "hspdll.h"
#include "hspsdk.h"

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
	case DLL_THREAD_ATTACH:
	case DLL_THREAD_DETACH:
	case DLL_PROCESS_DETACH:
		break;
	}
    return TRUE;
}

// ^Cv0
EXPORT BOOL WINAPI mmtInit(int p1, int p2, int p3, int p4)
{
	TIMECAPS caps;
	MMRESULT res = ::timeGetDevCaps(&caps, sizeof(TIMECAPS));
	if (res != TIMERR_NOERROR)
		return 1;
	if (caps.wPeriodMin != 1)
		return 2;
	res = ::timeBeginPeriod(1);
	if (res != TIMERR_NOERROR)
		return 3;
	return 0;
}

// ^Cv1
EXPORT BOOL WINAPI mmtGetTime(int *p1, int p2, int p3, int p4)
{
	*p1 = ::timeGetTime();
	return 0;
}

// ^Cv0
EXPORT BOOL WINAPI mmtFinal(int p1, int p2, int p3, int p4)
{
	MMRESULT res = ::timeEndPeriod(1);
	if (res != TIMERR_NOERROR)
		return 1;
	return 0;
}

// ^Cv1
EXPORT BOOL WINAPI tGetTickCount(DWORD *p1, int p2, int p3, int p4)
{
	*p1 = ::GetTickCount();
	return 0;
}

// ^Cv var
EXPORT BOOL WINAPI tQueryPerformanceFrequency(DWORD *p1, int p2, int p3, int p4)
{
	LARGE_INTEGER i;
	if (::QueryPerformanceFrequency(&i)) {
		*p1 = i.LowPart;
		*(LONG*)(p1+1) = i.HighPart;
		return 0;
	}
	return 1;
}

// ^Cv1
EXPORT BOOL WINAPI tQueryPerformanceCounter(DWORD *p1, int p2, int p3, int p4)
{
	LARGE_INTEGER i;
	if (::QueryPerformanceCounter(&i)) {
		*p1 = i.LowPart;
		*(LONG*)(p1+1) = i.HighPart;
		return 0;
	}
	return 1;
}

// ^Cv0
EXPORT BOOL WINAPI v3cQueryPerformanceCounter(int p1, int p2, int p3, int p4)
{
	LARGE_INTEGER i;
	if (::QueryPerformanceCounter(&i)) {
		return i.LowPart;
	}
	return 0;
}
