/*--------------------------------------------------------
	HSP DLL Development Kit support routines
  --------------------------------------------------------*/

#include <windows.h>
#include <windowsx.h>
#include <stdlib.h>
#include <stdio.h>
#include "hspdll.h"

//
//	HSP DLLT|[g[`Y:
//
//		̃Xgɂ́AHSPgpDLLŗLp
//		C̃[`LqĂ܂BBMSCR\̂pāA
//		HSP̃p[^ɃANZXꍇɕKvƂȂ
//		[`W߂Ă܂B
//		̃[`(hspsdk.cpp)́A[U[Ǝɍ쐬
//		DLLۂɎRɎgpĂ܂܂B
//		̃\[X͎RɉρANĂB
//		̃[`́AHSPŎۂɎgpĂ̂
//		HČJĂ܂ANꍇ̕ۏ؂
//		ł܂̂ŁA炩߂B
//		̃\[XɊւ鎿Ȃǂ́Aonitama@onionsoft.net
//		܂łǂB
//		ݎgpłA[`͈ȉ̒ʂłB
//
//	int valsize( PVAL2 *pv )
//
//		PVAL2\̂nƁAgpĂ郁TCY
//		oCgPʂŕԂ܂B
//
//	void bms_update( BMSCR *bm )
//
//		BMSCR\̂nƁÃEChD̍ĕ`sȂ
//		܂BHSṔuredraw 1vƓ悤ȓɂȂ܂B
//
//	void bms_send( BMSCR *bm, int x, int y, int sx, int sy )
//
//		BMSCR\̂ƁAX,YWAX,YTCYnƁAw
//		͈͂̍ĕ`sȂ܂BHSPredraw߂ŁA
//		ĕ`͈͂w肵Ɠ悤ȓɂȂ܂B
//
//		bms_updateƁAbms_send֐́ADLLŉʂ̏
//		sȂɁAۂɃEChDɔfꍇ
//		KvƂȂ̂łBʏA(EChD)ւ̕`́A
//		BMSCR\̂́AhdcoʂčsȂ܂B
//		GDI(WIN32API)ŕ`悷邽߂̊֐ŁAHDCw肷
//		p[^ɁAbmscr->hdc(ϐbmscrBMSCR *Ƃꍇ)
//		w肷΁ÃEChDɑ΂ĕ`悪sȂ܂B
//		́AzIȉʂ̃obt@ɕ`悪sȂ
//		Ȃ̂ŁAۂ̉ʏɂ͔f܂BA
//		ۂɔf邽߂̊֐2łB
//		͈͂قǍɏ܂B
//		`͈͂Sʂɋyԏꍇɂ́Abms_updateAꕔ
//		ꍇɂ́Abms_sendgpĂB
//
//
//	void bms_setcol( BMSCR *bm, int a1, int a2, int a3 )
//
//		RGB(a1,a2,a3)̐FR[hnƁAFBMSCR\̂
//		ݒ肳܂B́AHSPcolor߂ƓłB
//
//
//	void bms_setpal( BMSCR *bms, int colors, void *rgbptr )
//
//		BMSCR\̂œnEChD̃pbgeXV
//		[`łBcolorsɂ́AFArgbptrɂ́A1oCg
//		ƂR,G,B̓epbgf[^ւ̃|C^
//		w肵ĂB
//		̊֐gƂŁAobt@̃pbg͍XV
//		܂Aʏ̕\XVꍇ͕ʓrbms_update
//		ĂяoKv܂B
//		HSP ver2.4gȍ~ł́ArgbptrɎw肷邽߂̃pbg
//		f[^AhX擾łĂяo^Cv̂ŁA
//		̃AhXw肵ĂBȂꍇ́A
//		HSP̃XNvgőpalfade߂ɂtF[hC
//		AEgsȂƂł܂B
//
//
/*----------------------------------------------------------------*/

int valsize( PVAL2 *pv )
{
	//		calc object memory used size
	//			result : size(byte)
	int i,j;
	int vm=1;
	i=1;
	while(1) {
		j=pv->len[i];if (j==0) break;
		vm*=j;i++;if (i==5) break;
	}
	return vm<<2;
}

void bmspnt( HDC hdc, BMSCR *bm )
{
	HPALETTE opal;

	if (bm->hpal!=NULL) {
		opal=SelectPalette( hdc, bm->hpal, 0 );
		RealizePalette( hdc );
	}

	if (bm->type!=2) {
		//		Normal update
		//
		BitBlt( hdc,0,0,bm->wx, bm->wy, bm->hdc, bm->xx, bm->yy, SRCCOPY );
	}

	if (bm->hpal!=NULL) {
		SelectPalette( hdc, opal, 0 );
	}
}

void bms_update( BMSCR *bm )
{
	HDC hdc;
	if (bm->fl_udraw==0) return;
	hdc=GetDC( bm->hwnd );
	bmspnt(hdc,bm);
	ReleaseDC( bm->hwnd,hdc );
}

void bms_send( BMSCR *bm, int x, int y, int sx, int sy )
{
	HDC hdc;
	HPALETTE opal;
	if (bm->fl_udraw==0) return;
	hdc=GetDC( bm->hwnd );
	if (bm->hpal!=NULL) {
		opal=SelectPalette( hdc, bm->hpal, 0 );
		RealizePalette( hdc );
	}
	BitBlt( hdc, x-bm->xx, y-bm->yy, sx, sy, bm->hdc,x,y, SRCCOPY );
	if (bm->hpal!=NULL) {
		SelectPalette( hdc, opal, 0 );
	}
	ReleaseDC( bm->hwnd,hdc );
}


void bms_setcol( BMSCR *bm, int a1, int a2, int a3 )
{
	if (a1==-1) bm->color=PALETTEINDEX(a2);
		   else bm->color=RGB(a1,a2,a3);
	SetBkMode( bm->hdc,TRANSPARENT );
	SetTextColor( bm->hdc, bm->color );
	if ( bm->hbr != NULL ) DeleteObject( bm->hbr );
	bm->hbr = CreateSolidBrush( bm->color );
	if ( bm->hpn != NULL ) DeleteObject( bm->hpn );
	bm->hpn = CreatePen( PS_SOLID,0,bm->color );
}


void bms_setpal( BMSCR *bms, int colors, void *rgbptr )
{
	//		set palette to DIB & HPALETTE
	//			*rgbptr : R,G,B order palette entry
	//
	int a;
	BYTE *pt;
	RGBQUAD *bpal;
	LOGPALETTE *lpPal;
	HPALETTE hGetPal;

	if (bms->hpal != NULL ) {
		SelectPalette( bms->hdc, bms->holdpal, TRUE );
		DeleteObject( bms->hpal );
	}

	if (bms->palmode) {
		bpal=bms->pal;
		pt=(BYTE *)rgbptr;
		for(a=0;a<colors;a++) {
			bpal[a].rgbBlue  = pt[2];
			bpal[a].rgbRed   = pt[0];
			bpal[a].rgbGreen = pt[1];
			bpal[a].rgbReserved = 0;
			pt+=3;
		}
		SetDIBColorTable( bms->hdc, 0, colors, bpal );
	}

	//		make HPALETTE
	//
	lpPal = (LOGPALETTE *) malloc( 0x800 );		// size of Pal buffer 
	lpPal->palVersion = 0x300;
	lpPal->palNumEntries = (WORD) colors;
	pt=(BYTE *)rgbptr;
	for( a=0; a<colors; a++ ) {
		lpPal->palPalEntry[a].peRed		= pt[0];
		lpPal->palPalEntry[a].peGreen	= pt[1];
		lpPal->palPalEntry[a].peBlue	= pt[2];
		lpPal->palPalEntry[a].peFlags	= PC_NOCOLLAPSE;
		pt+=3;
	}
	hGetPal = CreatePalette( lpPal );
	bms->hpal = hGetPal;
	bms->holdpal = SelectPalette( bms->hdc, hGetPal, TRUE );
	free( lpPal );
	bms->pals = colors;
}

/*----------------------------------------------------------------*/


//
//	HSP DLLTv֐:
//
//		́ABMSCR\̂pʕ`̃Tv
//		܂BPȂTvȂ̂ŁAKvȂ΍폜
//		Ă肠܂B
//		GDI(WIN32API)gĂǂ̂悤ɕ`悷΂
//		QlɂĂ݂ĂB
//		̊֐́AۂHSPłgpĂ܂B
//
//	void bms_pset( BMSCR *bm, int xx,int yy )
//
//		pset߂Ŏs֐łBw肵WɁA
//		color߂Ŏw肳ꂽF̃hbg`悵܂B
//
//	void bms_boxf( BMSCR *bm,int x1,int y1,int x2,int y2 )
//
//		boxf߂Ŏs֐łBw肵`̈A
//		color߂őIꂽFœhԂ܂B
//
//	void bms_gzoom( BMSCR *tbm, int tx, int ty,
//					BMSCR *sbm, int xx, int yy, int sx, int sy )
//
//		gzoom߂Ŏs֐łBBMSCR\̂2
//		KvƂ܂Btbm͓]BMSCRAsbm͓]łB
//
//


void bms_boxf( BMSCR *bm,int x1,int y1,int x2,int y2 )
{
	//		boxf

	RECT bx;
	bx.left=x1;bx.top=y1;bx.right=x2+1;bx.bottom=y2+1;
	FillRect( bm->hdc, &bx, bm->hbr );
	bms_send( bm,x1,y1,x2-x1+1,y2-y1+1 );
}


void bms_pset( BMSCR *bm, int xx,int yy )
{
	//		pset

	SetPixel( bm->hdc,xx,yy,bm->color );
	bms_send( bm,xx,yy,1,1 );
}


void bms_gzoom( BMSCR *tbm, int tx, int ty,
				BMSCR *sbm, int xx, int yy, int sx, int sy )
{
	int x,y;
	x=tbm->cx;y=tbm->cy;
	SetStretchBltMode( tbm->hdc,COLORONCOLOR );
	StretchBlt(  tbm->hdc, x, y, tx, ty,
				 sbm->hdc, xx, yy, sx, sy, SRCCOPY );
	bms_send(tbm,x,y,tx,ty);
}



/*------------------------------------------------------------*/
/*
		(܂) Line Draw Routines (tJ[p)
*/
/*------------------------------------------------------------*/

void DrawLine( BMSCR *bm, int x1, int y1, int x2, int y2, int color )
{
	char *lpDest;		// `ʂ̃obt@
	int nDestWByte;		// `Wbyte
	int nDestWidth;		// `W
	int nDestHeight;	// `W
	int DestSize;		// `ʃobt@̃TCY
    int i, x, y, dx, dy, addx, addy;
	short color1;
	unsigned char color2;
	unsigned char *up;
	char *dwDest;
    int cnt = 0;

	lpDest = (char *)bm->pBit;
	nDestWidth = bm->sx;
	nDestWByte = bm->sx*3;
	nDestHeight = bm->sy;
	DestSize = bm->sx*bm->sy*3;

	dwDest = lpDest + ((nDestHeight-1)*nDestWByte);
	color1 = (short)(color & 0xffff);
	color2 = (unsigned char)( (color & 0xff0000 ) >>16 );

    dx = x2 - x1;
    if (dx < 0){ addx = -1; dx = -dx; } else addx = 1;
    dy = y2 - y1;
    if (dy < 0){ addy = -1; dy = -dy; } else addy = 1;
    x = x1; y = y1;

    if (dx > dy){
        for (i = 0; i < dx; ++i){
			if ((y>=0)&&(y<nDestHeight)&&(x>=0)&&(x<nDestWidth)) {
				up = (unsigned char *)(dwDest - nDestWByte*y + x*3 );
				*(short *)up = color1; up[2] = color2;
			}
            cnt += dy; x += addx;
            if (cnt >= dx){ cnt-=dx; y+=addy; }
        }
    }
    else{
        for (i = 0; i < dy; ++i){
			if ((y>=0)&&(y<nDestHeight)&&(x>=0)&&(x<nDestWidth)) {
				up = (unsigned char *)(dwDest - nDestWByte*y + x*3 );
				*(short *)up = color1; up[2] = color2;
			}
            cnt += dx; y += addy;
            if (cnt >= dy){ cnt-=dy; x+=addx; }
        }
    }
	return;
}


/*----------------------------------------------------------------*/
