#include "stdafx.h"
#include "hsp3plugin.h"

LARGE_INTEGER hrpc_frequency;
HRPC_COUNT hrpc_count[2];
HRPC_COUNT * hrpc_countp = hrpc_count;

// ^Cv var
EXPORT BOOL WINAPI mmtGetTime( int *p1 )
{
	*p1 = ::timeGetTime();
	return 0;
}

// ^Cv var
EXPORT BOOL WINAPI getTickCount(DWORD *p1)
{
	*p1 = ::GetTickCount();
	return 0;
}

// ^Cv var
EXPORT BOOL WINAPI queryHRPFrequency(DWORD *p1)
{
	LARGE_INTEGER i;
	if (::QueryPerformanceFrequency(&i)) {
		*p1 = i.LowPart;
		*(LONG*)(p1+1) = i.HighPart;
		return 0;
	}
	return 1;
}

// ^Cv var
EXPORT BOOL WINAPI queryHRPCounter(DWORD *p1)
{
	LARGE_INTEGER i;
	if (::QueryPerformanceCounter(&i)) {
		*p1 = i.LowPart;
		*(LONG*)(p1+1) = i.HighPart;
		return 0;
	}
	return 1;
}

// ^Cv Ȃ
EXPORT BOOL WINAPI initHRPCounter()
{
	if (::QueryPerformanceFrequency(&hrpc_frequency)) {
		hrpc_countp = hrpc_count;
		hrpc_count[0].p = hrpc_count + 1;
		hrpc_count[1].p = hrpc_count;
		if (::QueryPerformanceCounter(&hrpc_countp->p->c)) {
			return 0;
		}
	}
	return 1;
}

// ^Cv var
EXPORT BOOL WINAPI aqueryHRPmicrosec(int *p1)
{
	::QueryPerformanceCounter(&hrpc_countp->c);
	hrpc_countp = hrpc_countp->p;
	*p1 = static_cast<int>(double(hrpc_countp->p->c.QuadPart - hrpc_countp->c.QuadPart) / hrpc_frequency.QuadPart * 1000000);
	return 0;
}

// cfunc ^Cv Ȃ
EXPORT BOOL WINAPI aqueryHRPmicrosec_cfunc()
{
	::QueryPerformanceCounter(&hrpc_countp->c);
	hrpc_countp = hrpc_countp->p;
	return static_cast<int>(double(hrpc_countp->p->c.QuadPart - hrpc_countp->c.QuadPart) / hrpc_frequency.QuadPart * 1000000);
}

// cfunc ^Cv Ȃ
EXPORT BOOL WINAPI aqueryHRPmicrosec_n_cfunc()
{
	::QueryPerformanceCounter(&hrpc_countp->c);
	return static_cast<int>(double(hrpc_countp->c.QuadPart - hrpc_countp->p->c.QuadPart) / hrpc_frequency.QuadPart * 1000000);
}
